;

// TODO: enqueue this file asynchronously only when front-end Builder is active.

(function($, window, document, undefined){

    "use strict";

    var SliderProFront = {
        init: function() {
            var self = SliderProFront;

            self.bindEvents();
        },

        bindEvents: function() {
            var self = SliderProFront;

            $(document).on('tfb.live_styling.after_create', self.bindLiveStyling);
        },


        bindLiveStyling: function(e, liveStylingInstance) {
            var bindInputsWithUnit, bindFontFamilies, bindColors;
            
            bindInputsWithUnit = function() {
                var inputsWithUnit = {
                    '.bsp-slide-post-title': [
                        ['#font_size_title', 'font-size' ],
                        ['#line_height_title', 'line-height' ]
                    ],
                    '.bsp-slide-excerpt': [
                        ['#font_size_text', 'font-size' ],
                        ['#line_height_text', 'line-height' ]
                    ],
                    '.bsp-slide-excerpt p': [
                        ['#font_size_text', 'font-size' ],
                        ['#line_height_text', 'line-height' ]
                    ],
                    '.bsp-slide-button': [
                        ['#font_size_button', 'font-size' ],
                        ['#line_height_button', 'line-height' ]
                    ]
                };

                Object.keys(inputsWithUnit).forEach(function(selector) {
                    inputsWithUnit[selector].forEach(function(item) {
                        liveStylingInstance.textInputWithUnit(
                            item[0],
                            item[1],
                            [selector]
                        );
                    });
                });
            };

            bindFontFamilies = function() {
                liveStylingInstance.fontFamily('#title_font_family', 'font-family', ['.bsp-slide-post-title']);

                liveStylingInstance.fontFamily(
                    '#text_font_family',
                    'font-family',
                    ['.bsp-slide-excerpt', '.bsp-slide-excerpt p']
                );

                liveStylingInstance.fontFamily('#button_font_family', 'font-family', ['.bsp-slide-button']);
            };

            bindColors = function() {
                $('body').on('themify_builder_color_picker_change', function(e, colorType, rgbaString) {
                    var newStyle = {};
                    var colorCSSRule = '';

                    if (colorType === 'timer_bar_background_color') {
                        colorCSSRule = 'background-color';

                        newStyle[colorCSSRule] = rgbaString;

                        liveStylingInstance.setLiveStyle(newStyle, ['.bsp-timer-bar']);
                    }
                });

            };

            bindInputsWithUnit();
            bindFontFamilies();
            bindColors();
        }
    };

    SliderProFront.init();

}(jQuery, window, document));
